/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "experimenter/horizon.h"

using namespace TkResolver;
using namespace Experimenter;

Horizon:: Horizon(Speed *speed)
  : Gtk::VScale(0.0, 1.0, 0.1),
    _adjustment(0.6, 0.0, 1.0, 0.01, 0.1)
{
  set_digits(3);
  set_adjustment(_adjustment);
  set_draw_value();
  set_value_pos(Gtk::POS_BOTTOM);
  
  speed->signal_scroll_changed()->connect( sigc::mem_fun(*this, &Horizon::scroll_toggled) );
}

void
Horizon:: scroll_toggled(bool scroll)
{
  set_sensitive(scroll);
}

double
Horizon:: get_horizon() const
{
  return get_value();
}
