/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <stdexcept>

#include "maths.h"


unsigned short
TkResolver:: find_next_power_of_two_power(unsigned n)
{
  if (n == 0)
    throw std::invalid_argument("2^n cannot equal 0");
  if (n == 1)
    return 0;

  unsigned pot;
  unsigned short power;

  for (power = 0, pot = 0;
       pot < n;
       pot = 1U << ++power);

  return power;
}

unsigned short
TkResolver:: find_next_power_of_two(unsigned n)
{
  return 1U << find_next_power_of_two_power(n);
}
