/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DB_UI_DATA_SELECTOR_LIST_H__
#define __TK_DB_UI_DATA_SELECTOR_LIST_H__

#include <gtkmm.h>

#include "data_selector.h"

namespace TkResolver {
  namespace Db {
    namespace Ui {

      typedef Gtk::TreeViewColumn::SlotCellData SlotListCellData;
      typedef DisplayColumnInfo<SlotListCellData> ListColumnInfo;
      typedef std::list<ListColumnInfo> ListColumnList;
      typedef DisplayColumnAdaptor<Gtk::TreeViewColumn> ListColumnAdaptor;
      
      void append_selection(const Gtk::TreeModel::iterator & iter, ModelIteratorList * list);
      
      class DataSelectorList : public DataSelector, public Gtk::Frame
	{
	private:
	  Gtk::ScrolledWindow                   _view_scroll;
	  Gtk::TreeView                         _view;
	  Gtk::HBox                             _box;
	  
	  void create_widgets(const ListColumnList & display_columns);
	protected:
	  
	  DataSelectorList(Db::Database * database,
			   const String &table_name,
			   const StringList &selection_columns,
			   const String &title);
	  // should be called immediately after constructor
	  void set_display_columns(const ListColumnList & display_columns);

	  Gtk::TreeView & get_view();
	  Gtk::HBox & get_box();
	  virtual ModelIteratorList get_selected() const;
	  virtual void select(Gtk::TreeModel::iterator &iter);
	};

    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace TkResolver */




#endif /* __TK_DB_UI_DATA_SELECTOR_LIST_H__ */
