/* 
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <memory>
#include <iostream>

#include <odbc++/drivermanager.h>
#include <odbc++/databasemetadata.h>
#include <odbc++/resultset.h>

#include "libtkcommon/debug.h"

int
main(int argc, char **argv)
{
  std::string dsn("TkResolver++");
  std::string usr("psi");
  std::string pwd("isp");
  
  
  DEBUG_OUT << "Connecting to database..." << std::endl;
  std::auto_ptr<odbc::Connection> conn( odbc::DriverManager::getConnection(dsn, usr, pwd) );
  DEBUG_OUT << "...connected to database" << std::endl;
  
  DEBUG_OUT << "Getting metadata..." << std::endl;
  odbc::DatabaseMetaData *metadata( conn->getMetaData() );
  DEBUG_OUT << "...got metadata" << std::endl;
  
  
  DEBUG_OUT << "Getting columns..." << std::endl;
  std::auto_ptr<odbc::ResultSet> result( metadata->getColumns("", "", "experiment", "") );
  DEBUG_OUT << "...got columns" << std::endl;
  
  
  DEBUG_OUT << "Iterating over column metadata..." << std::endl;
  for (result->next(); !result->isAfterLast(); result->next())
    {
      DEBUG_OUT << "  column: " << result->getString(4) << std::endl;
    }
  DEBUG_OUT << "...iterated over column metadata" << std::endl;
}
