/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <wchar.h>

#include <stdlib.h>
#include <getopt.h>

#include "libtkcommon/debug.h"
#include "libtkrandom/randomness.h"

using namespace TkResolver;
using namespace Random;

void
test_value(unsigned long upper)
{
  unsigned long value;
  value = Randomness::get_number(upper); //, "pseudo");
  DEBUG_OUT << "upper: "
	    << upper
	    << "; value: "
	    << value
	    << std::endl;
}

void
test_average(unsigned long upper, unsigned n)
{
  unsigned long avg = 0;
  for (unsigned i = 0; i < n; ++i)
    avg += Randomness::get_number(upper);

  avg /= n;

  DEBUG_OUT << "upper: "
	    << upper
	    << "; n: "
	    << n
	    << "; average: "
	    << avg
	    << std::endl;
}

int
main (int argc, char ** argv)
{
  /*  for (unsigned long upper(30000);
       upper < 20000000;
       upper += 100000)
    {
      test_upper(upper);
      }*/

  //  for (unsigned long upper(10); upper < 20; ++upper)
  //    test_value(upper);

  for (unsigned i = 0; i < 10; ++i)
    test_value(20);

  for (unsigned short i = 0; i < 5; ++i)
    test_average(1000, 1000);
  for (unsigned short i = 0; i < 5; ++i)
    test_average(10000, 1000);

  return 0;
}
